package infomat.mro;

import infomat.algorithms.grouping.*;
import infomat.bridges.tct.algorithms.grouping.*;
import infomat.algorithms.labeling.*;
import infomat.evaluation.*;
import infomat.io.*;
import infomat.vectorspace.*;
import infomat.vectorspace.similarity.*;
import infomat.vectorspace.weighting.*;

import mro.util.*;
import mro.util.properties.*;
import mro.util.measures.*;

import java.io.*;
import java.util.HashMap;
import java.util.Vector;

import org.xml.sax.SAXException;

// java -cp .:classes/:lib/tct-core.jar:lib/tct-matrix.jar:lib/tct-text.jar -Xms3024m -Xmx3024m infomat.Experimentator -experimentPath "/afs/nada.kth.se/home/f/u1ya3frf/Code/tmp/ClusterDescriptionExperiments080329/settings/Repeat10WordsJtteliten/"

// java -cp .:classes/:lib/tct-core.jar:lib/tct-matrix.jar:lib/tct-text.jar -Xms3024m -Xmx3024m infomat.Experimentator -experimentPath "/afs/nada.kth.se/home/f/u1ya3frf/Code/tmp/ClusterDescriptionExperiments080329/settings/Repeat10WordsA1/"

// java -cp .:classes/:lib/tct-core.jar:lib/tct-matrix.jar:lib/tct-text.jar -Xms2024m -Xmx2024m infomat.Experimentator -experimentPath "/afs/nada.kth.se/home/f/u1ya3frf/Code/tmp/ClusterDescriptionExperiments080329/settings/Repeat5WordsA1/"

// java -cp .:classes/:lib/tct-core.jar:lib/tct-matrix.jar:lib/tct-text.jar -Xms3024m -Xmx3024m infomat.Experimentator -experimentPath "/afs/nada.kth.se/home/f/u1ya3frf/Code/tmp/ClusterDescriptionExperiments080329/settings/Repeat20nTest10Words/"

// java -cp .:classes/:lib/tct-core.jar:lib/tct-matrix.jar:lib/tct-text.jar -Xms3024m -Xmx3024m infomat.Experimentator -experimentPath "/afs/nada.kth.se/home/f/u1ya3frf/Code/tmp/ClusterDescriptionExperiments080329/settings/Repeat20nTest5Words/"


// java -cp .:classes/:lib/tct-core.jar:lib/tct-matrix.jar:lib/tct-text.jar -Xms3024m -Xmx3024m infomat.Experimentator -experimentPath "/afs/nada.kth.se/home/f/u1ya3frf/Code/tmp/ClusterDescriptionExperiments080401/settings/Repeat20nTest10Words/"

// java -cp .:classes/:lib/tct-core.jar:lib/tct-matrix.jar:lib/tct-text.jar -Xms3024m -Xmx3024m infomat.Experimentator -experimentPath "/afs/nada.kth.se/home/f/u1ya3frf/Code/tmp/ClusterDescriptionExperiments080402/settings/Repeat20nTest10Words/"

// java -cp .:classes/:lib/tct-core.jar:lib/tct-matrix.jar:lib/tct-text.jar -Xms3024m -Xmx3024m infomat.Experimentator -experimentPath "/afs/nada.kth.se/home/f/u1ya3frf/Code/tmp/ExperimentatorTestJtteliten/settings/"


// java -cp .:classes/:lib/tct-core.jar:lib/tct-matrix.jar:lib/tct-text.jar -Xms3024m -Xmx3024m infomat.Experimentator -experimentPath "/afs/nada.kth.se/home/f/u1ya3frf/Code/tmp/ClusterDescriptionExperiments080512/settings/Repeat10WordsA1/"

// java -cp .:classes/:lib/tct-core.jar:lib/tct-matrix.jar:lib/tct-text.jar -Xms3024m -Xmx3024m infomat.Experimentator -experimentPath "/afs/nada.kth.se/home/f/u1ya3frf/Code/tmp/ExperimentatorTestJtteliten/settings/"

// nice -10 java -cp .:classes/:lib/tct-core.jar:l/tct-matrix.jar:lib/tct-text.jar -Xms3024m -Xmx3024m infomat.ExperimentatorNumberOfWords -experimentPath "/afs/nada.kth.se/home/f/u1ya3frf/Code/tmp/NumberOfWords080517/settings/A1/"

// nice -10 java -cp .:classes/:lib/tct-core.jar:l/tct-matrix.jar:lib/tct-text.jar -Xms3024m -Xmx3024m infomat.ExperimentatorNumberOfWords -experimentPath "/afs/nada.kth.se/home/f/u1ya3frf/Code/tmp/NumberOfWords080517/settings/20ngTest/"

// nice -10 java -cp .:classes/:lib/tct-core.jar:l/tct-matrix.jar:lib/tct-text.jar -Xms3024m -Xmx3024m infomat.ExperimentatorReductionReduction -experimentPath "/afs/nada.kth.se/home/f/u1ya3frf/Code/tmp/ReductionReduction080520/settings/20ngTest/"

// java -cp .:classes/:lib/tct-core.jar:lib/tct-matrix.jar:lib/tct-text.jar -Xms3024m -Xmx3024m infomat.ExperimentatorReductionReduction -experimentPath "/afs/nada.kth.se/home/f/u1ya3frf/Code/tmp/ReductionReduction080601/settings/20ngTest/"



/**
 *
 * NOT WORKING IN VERSION 080828
 *
 * Class for running clustering tasks without the GUI.
 *
 * The arguments of the main()-method overruns the default properties.
 * If a properties-file for the Experimentator-object 
 * is specified (or located) it takes precedence.
 *
 * <br>
 * <br>
 * <code>java -cp .:classes/ -Xms3024m -Xmx3024m infomat.Experimentator</code>
 *
 * @version          080219
 * @author           Magnus Rosell
 *
 */
public class ExperimentatorReductionReduction implements HasProperties{

    private static String sweStoplistFileName = "/afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/stoppord/Stoplist.txt";
    private static String engStoplistFileName = "/afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/english/porter_plus_glasgow_stoplist.txt";

    private Properties properties = null;

    private PropertiesPool pp = new PropertiesPool();
    
    public ExperimentatorReductionReduction(){
	this.properties = getDefaultProperties();
    }


    public Properties getDefaultProperties(){

	Properties properties = 
	    new Properties("Experimentator Properties", CurrentClassGetter.getClassName());
		
	try{
			
	    /****************/
	    Property p = new Property("Number of iterations", 1, "Number of iterations");
	    properties.addProperty(p);

	    /****************/
	    p = new Property("In File Type", 0, "What kind of file for input");
	    PropertyValueDescription pvd = new PropertyValueDescription("0", "Use \"Matrix File\"");
	    p.addValueDescription(pvd);
	    pvd = new PropertyValueDescription("1", "Use \"Inpath\" recursively");
	    p.addValueDescription(pvd);
	    pvd = new PropertyValueDescription("2", "Use \"Token File\"");
	    p.addValueDescription(pvd);
	    pvd = new PropertyValueDescription("3", "Use \"Corpus File\"");
	    p.addValueDescription(pvd);
	    properties.addProperty(p);

	    p = new Property("Matrix File", null, "Matrix File");
	    properties.addProperty(p);
	    p = new Property("Token File", null, "Token File");
	    properties.addProperty(p);
	    p = new Property("Corpus File", null, "Corpus File");
	    properties.addProperty(p);
	    p = new Property("Inpath", null, "Path from where files are read recursively");
	    properties.addProperty(p);

	    /****************/
	    p = new Property("Comparison Grouping", 0, "How to get a comparison grouping");
	    pvd = new PropertyValueDescription("0", "None, or use what's given as main()-argument");
	    p.addValueDescription(pvd);
	    pvd = new PropertyValueDescription("1", "Use \"IObjectGrouping File\"");
	    p.addValueDescription(pvd);
	    pvd = new PropertyValueDescription("2", "Construct from IObject location");
	    p.addValueDescription(pvd);
	    pvd = new PropertyValueDescription("3", "Use \"DocumentGrouping File\"");
	    p.addValueDescription(pvd);
	    properties.addProperty(p);


	    p = new Property("DocumentGrouping File", null, "DocumentGrouping File");
	    properties.addProperty(p);
	    p = new Property("IObjectGrouping File", null, "IObjectGrouping File");
	    properties.addProperty(p);


	    /****************/
	    p = new Property("Language", 0, "What language is used (for stoplist)");
	    pvd = new PropertyValueDescription("0", "Swedish");
	    p.addValueDescription(pvd);
	    pvd = new PropertyValueDescription("1", "English");
	    p.addValueDescription(pvd);
	    properties.addProperty(p);


	    /****************/
	    p = new Property("Experiment result type", 0, "What kind of experiment");
	    pvd = new PropertyValueDescription("0", "Use \"Result Path\" for output.");
	    p.addValueDescription(pvd);
	    pvd = new PropertyValueDescription("1", "Read properties from subdirectories of \"Experiment Path\" and write results in the same place");
	    p.addValueDescription(pvd);
	    pvd = new PropertyValueDescription("2", "Read properties from subdirectories of \"Experiment Path\" and write results in a similar structure with the root at \"Experiment Result Path\"");
	    p.addValueDescription(pvd);
	    properties.addProperty(p);

	    p = new Property("Result Path", null, "Path for result");
	    properties.addProperty(p);

	    p = new Property("Experiment Path", null, "Path where the experiment(s) are specified");
	    properties.addProperty(p);

	    p = new Property("Experiment Result Path", null, "Path where the experiment(s) results are written");
	    properties.addProperty(p);

			
	}catch(PropertyNameConflictException pnce){
	    // Won't happen here
	}
	return properties;
    }

    public Object getPropertyValue(String name){
    	return properties.getPropertyValue(name);
    }
    public void setProperty(String name, Object value) throws PropertyNotFoundException{
    	properties.setProperty(name, value);
    }

    public mro.util.properties.Properties getProperties(){
    	return properties;
    }

    public void setProperties(mro.util.properties.Properties properties){
    	this.properties=properties;
    }




    public static void main(String[] args) 
	throws org.xml.sax.SAXException, IOException, 
	       PropertyNotFoundException{
	ExperimentatorReductionReduction exp = 
	    new ExperimentatorReductionReduction();
	exp.doIt(args);
    }

    private IMatrix originalMatrix = null;
    private IObjectGrouping originalCategorization = null;

    public void doIt(String[] args) 
	throws IOException, SAXException, PropertyNotFoundException{

	checkInput(args);

	readFiles();

	stoplist();

	    System.out.println("0. Matrix: "+matrix.getSize());
	    System.out.println("0. Categorization: ");
	    categorization.printGroupSizes();

	originalMatrix = new IMatrix(matrix);
	originalCategorization = new IObjectGrouping(categorization);

	    System.out.println("0b. Matrix: "+originalMatrix.getSize());
	    System.out.println("0b. Categorization: ");
	    originalCategorization.printGroupSizes();


	String experimentPath =  (String) getPropertyValue("Experiment Path");
	if(experimentPath!=null){
	    File path = new File(experimentPath);
	    recurseExperimentPath(path);
	}else{

	    similarity = constructSimilarity();
	    Vector<GroupingAlgorithm> algs = getAlgorithms();

	    if(algs.size()>0){
		filter();

		Weighter weighter = weight();
		
		String resultPath =  (String) getPropertyValue("Result Path");
		if(!resultPath.endsWith(File.separator))
		    resultPath += File.separator;
		
		int iter = (Integer) getPropertyValue("Number of iterations");
		for(int i=0; i<iter; i++)
		    cluster(resultPath, algs, weighter);
	    }
	}
    }

    private void recurseExperimentPath(File path) 
	throws IOException, SAXException{
	if(!path.isDirectory())
	    badInput("Specified \"Experiment Path\" not a path!");

	System.out.println("recurseExperimentPath(): "+path.getPath());
	File[] list = path.listFiles();
	for(int i=0; i<list.length; i++){
	    if(list[i].isDirectory()){
		doOneDirectory(list[i]);
		recurseExperimentPath(list[i]);
	    }
	}
    }

    private void doOneDirectory(File dir) throws IOException, SAXException{
	pp = new PropertiesPool();
	pp.loadPropertiesInDirectory(dir);

	similarity = constructSimilarity();

	int expResType =  (Integer) 
	    getPropertyValue("Experiment result type");
	String resultPath =  (String) getPropertyValue("Result Path");
	String experimentPath =  (String) getPropertyValue("Experiment Path");
	String experimentResultPath = (String) 
	    getPropertyValue("Experiment Result Path");
	if(expResType==0 && resultPath!=null)
	    resultPath=resultPath;
	else if(expResType==1 && experimentPath!=null)
	    resultPath = dir.getName();
	else if(expResType==2 && 
		experimentPath!=null && 
		experimentResultPath!=null){
	    String currentPath = dir.getPath();
	    String ending = currentPath.substring(experimentPath.length(), 
						  currentPath.length());
	    resultPath = experimentResultPath + ending;

	    File path = new File(resultPath);
	    if(!path.exists())
		path.mkdirs();

	    pp.savePropertiesToDirectory(path);

	}else
	    badInput("Bad result path!");

	Vector<GroupingAlgorithm> algs = getAlgorithms();
	if(algs.size()>0){
	    int iter = (Integer) getPropertyValue("Number of iterations");
	    for(int i=0; i<iter; i++){
		
		System.out.println("1. Matrix: "+matrix.getSize());
		System.out.println("1. Categorization: ");
		categorization.printGroupSizes();
		
		matrix = new IMatrix(originalMatrix);
		categorization = new IObjectGrouping(originalCategorization);
		
		System.out.println("2. Matrix: "+matrix.getSize());
		System.out.println("2. Categorization: ");
		categorization.printGroupSizes();
		
		filter();
		
		algs = getAlgorithms();

		System.out.println("3. Matrix: "+matrix.getSize());
		System.out.println("3. Categorization: ");
		categorization.printGroupSizes();
		
		Weighter weighter = weight();
		if(!resultPath.endsWith(File.separator))
		    resultPath += File.separator;
		cluster(resultPath, algs, weighter);
	    }
	}
    }


    // OBS tar den sista av de similarities som finns.
    private SparseISimilarity constructSimilarity(){

	Vector<Properties> props = 
	    pp.getPropertiesWithSuperClassName("infomat.vectorspace.similarity.SparseISimilarity");
	for(int i=0; i<props.size(); i++){
	    Properties p = props.elementAt(i);
	    String className = p.getOwnerClassName();
	    System.out.println("Similarity : "+className);
	    try{
		Class c = Class.forName(className);
		similarity = (SparseISimilarity) c.newInstance();
		similarity.setProperties(p);

		if(similarity instanceof NeedsIMatrix){
		    ((NeedsIMatrix)similarity).setIMatrix(matrix);
		}
		if(similarity instanceof NeedsIMatrixDimension){
		    boolean row=true;
		    ((NeedsIMatrixDimension)similarity).setIMatrixDimension(row);
		}


		System.out.println("Similarity : "+className);
	    }catch(ClassNotFoundException cnfe){
		// Do nothing
		System.out.println("ClassNotFoundException cnfe){");
	    }catch(InstantiationException ie){
		// Do nothing
		System.out.println("InstantiationException ie){");
	    }catch(IllegalAccessException iae){
		// Do nothing
		System.out.println("IllegalAccessException iae){");
	    }
	}
	return similarity;
    }


    private Vector<GroupingAlgorithm> getAlgorithms(){
	System.out.println("getAlgorithms()");
	Vector<GroupingAlgorithm> algs = new Vector<GroupingAlgorithm>();
	Vector<Properties> props = 
	    pp.getPropertiesWithSuperClassName("infomat.algorithms.grouping.GroupingAlgorithm");
	for(int i=0; i<props.size(); i++){
	    Properties p = props.elementAt(i);
	    String className = p.getOwnerClassName();
	    System.out.println("Clustering algortihm: "+className);
	    try{
		Class c = Class.forName(className);
		GroupingAlgorithm ga = (GroupingAlgorithm) c.newInstance();
		ga.setProperties(p);

		if(ga instanceof NeedsIMatrix)
		    ((NeedsIMatrix) ga).setIMatrix(matrix);
		if(ga instanceof NeedsISimilarity){
		    System.out.println("Similarity!!!!");
		    System.out.println("alg: "+ga);
		    System.out.println("sim: "+similarity);
		    ((NeedsISimilarity) ga).setSimilarity(similarity);
		}
		algs.add(ga);
	    }catch(ClassNotFoundException cnfe){
		// Do nothing
	    }catch(InstantiationException ie){
		// Do nothing
	    }catch(IllegalAccessException iae){
		// Do nothing
	    }
	}
	return algs;
    }


    private void cluster(String resultPath, Vector<GroupingAlgorithm> algs, Weighter weighter){

	System.out.println("cluster(): "+matrix.getSize());

	// Klustra
	IObjectSet set = matrix.getRowIObjectSet();
					
	
	for(int i=0; i<algs.size(); i++){
	    GroupingAlgorithm alg = algs.elementAt(i);
	    System.out.println("******************* "+alg);
	    oneClustering(resultPath, alg, weighter, matrix);

	    /*
	    IObjectGrouping clustering = alg.cluster(set);
	    clustering.removeEmptyGroups();
	    evaluate(resultPath, weighter, clustering, matrix);
	    */
	}

    }

    private void oneClustering(String resultPath, GroupingAlgorithm alg, 
			       Weighter weighter, IMatrix matrix){

	similarity = constructSimilarity();

	System.out.println("oneClustering(): "+matrix.getSize());


	long timeStamp = System.currentTimeMillis();

	IObjectSet set = matrix.getRowIObjectSet();

	/*******************/

	IObjectGrouping clustering = alg.cluster(set);
	clustering.removeEmptyGroups();

	// Evaluation
	categorization = new IObjectGrouping(originalCategorization);
	categorization.removeObjectsNotIn(clustering);

	String newResPath = resultPath+"clustering"+File.separator;
	fixPath(newResPath);
	String resFile = newResPath+"clusteringEvaluation."+timeStamp+".xml";
	calculateAndSaveEvaluation(matrix, clustering, categorization, resFile, timeStamp);
	
	//	clustering.printGroupsRepresentationObjects(15, matrix);
	clustering.printGroupSizes();
	System.out.println("Clustered!!!");


	/*******************/

	LabelReducer labelReducer = new LabelReducer();
	Properties props = pp.getPropertiesForObject(labelReducer);
	if(props!=null)
	    labelReducer.setProperties(props);


	/*******************/

	// Centroid Labeling
	CentroidLabeler centroidLabeler = new CentroidLabeler();
	String designation = "Phi";
	oneReductionExperiment(resultPath, clustering, labelReducer, centroidLabeler, alg, designation, timeStamp);

	/*******************/

	// Centroid Ranking Boost Labelling
	CentroidRankingBoostLabeler centroidRankingBoostLabeler = 
	    new CentroidRankingBoostLabeler();
	designation = "DeltaLrCe";
	oneReductionExperiment(resultPath, clustering, labelReducer, centroidRankingBoostLabeler, alg, designation, timeStamp);

	/*******************/

	// Combined Centroid Labeling
	CombinedCentroidLabeler combinedCentroidLabeler = 
	    new CombinedCentroidLabeler();
	designation = "Pi";
	oneReductionExperiment(resultPath, clustering, labelReducer, combinedCentroidLabeler, alg, designation, timeStamp);



    }




    private void fixPath(String pathName){
	File path = new File(pathName);
	if(!path.exists())
	    path.mkdirs();
    }


    private void oneReductionExperiment(String resultPath, 
					IObjectGrouping clustering, 
					LabelReducer labelReducer,
					Labeler labeler, 
					GroupingAlgorithm alg, 
					String designation,
					long timeStamp
					){

	String originalDesignation = designation;
	IObjectGrouping originalClustering = 
	    new IObjectGrouping(clustering);

	int[] nrWordsArr = {1, 3, 5, 10, 20};

	//	for(int nrWords=1; nrWords<=20; nrWords++){
	for(int i=0; i<nrWordsArr.length; i++){
	    int nrWords = nrWordsArr[i];

	    String nrDesignation = originalDesignation+nrWords+"words";
	    if(nrWords<10)
		nrDesignation = originalDesignation+"0"+nrWords+"words";

	    try{
		labeler.setProperty("Number of objects in labels", nrWords);
	    }catch(PropertyNotFoundException pnfe){
		System.out.println("oneReductionExperiment(): Number of objects in labels");
		System.exit(0);
	    }

	    clustering = new IObjectGrouping(originalClustering);
	    for(int redNr = 1; 
		redNr<=10 && clustering.numberOfIObjects() > 0; 
		redNr++){

		designation = nrDesignation + redNr + "reds";
		if(redNr<10)
		    designation = nrDesignation + "0" + redNr + "reds";


		HashMap<IObjectGroup, ILabel> labeling = 
		    labeler.labelGrouping(clustering, similarity);//, matrix);
		Labeler.printLabeling(clustering, labeling);
		System.out.println("Labeled!!! "+labeling.getClass().getName());
		
		
		// Label Reduce
		IObjectGrouping[] labelIOGINGs = labelReducer.reduceGroupingByLabeling(clustering, labeling, matrix, similarity);
		IObjectGrouping labelReducedClustering = labelIOGINGs[0];
		labelReducedClustering.printGroupSizes();
		System.out.println("Label Reduced!!!"+labeling.getClass().getName());
		
		
		// Evaluation 
		categorization = new IObjectGrouping(originalCategorization);
		categorization.removeObjectsNotIn(labelReducedClustering);
		
		// This has to be done here!
		// Since otherwise Size Reduction might fault
		labelReducedClustering.removeEmptyGroups();
		
		String newResPath = resultPath+designation+File.separator;
		fixPath(newResPath);
		String resFile = newResPath+designation+"Evaluation."+timeStamp+".xml";
		calculateAndSaveEvaluation(matrix, labelReducedClustering, categorization, resFile, timeStamp);
		
		clustering = labelReducedClustering;
	    }


	}

    }


    /*
    private void evaluate(String resultPath, Weighter weighter, 
			  IObjectGrouping clustering, IMatrix matrix){

	long timeStamp = System.currentTimeMillis();

	// Evaluation
	categorization = new IObjectGrouping(originalCategorization);
	categorization.removeObjectsNotIn(clustering);

	String newResPath = resultPath+"clustering"+File.separator;
	fixPath(newResPath);
	String resFile = newResPath+"clusteringEvaluation."+timeStamp+".xml";
	calculateAndSaveEvaluation(matrix, clustering, categorization, resFile, timeStamp);
	
	clustering.printGroupsRepresentationObjects(15, matrix);
	clustering.printGroupSizes();
	System.out.println("Clustered!!!");

	// Label
	//	HashMap<IObjectGroup, ILabel> labeling = 
	//	    Labeler.simpleLabelGrouping(clustering, matrix);
	//	HashMap<IObjectGroup, ILabel> labeling = 
	//	    Labeler.relativeFrequencyLabelGrouping(clustering, matrix);
	//	HashMap<IObjectGroup, ILabel> labeling = 
	//	    Labeler.frequentAndPredictiveLabelGrouping(clustering, matrix);

	////////////////////

	LabelReducer labelReducer = new LabelReducer();
	Properties props = pp.getPropertiesForObject(labelReducer);
	if(props!=null)
	    labelReducer.setProperties(props);


	////////////////////

	// Weight Ranking Labelling
	WeightRankingBoostLabeler weightRankingBoostLabeler = 
	    new WeightRankingBoostLabeler(weighter);
	String designation = "weightRankingLabelReducedClustering";	
	oneReductionExperiment(resultPath, clustering, labelReducer, weightRankingBoostLabeler, designation, timeStamp);
	

	////////////////////

	// Centroid Ranking Labelling
	CentroidRankingBoostLabeler centroidRankingBoostLabeler = 
	    new CentroidRankingBoostLabeler();
	designation = "centroidRankingLabelReducedClustering";
	oneReductionExperiment(resultPath, clustering, labelReducer, weightRankingBoostLabeler, designation, timeStamp);

	////////////////////

	// Centroid Labeling
	CentroidLabeler centroidLabeler = new CentroidLabeler();
	designation = "centroidLabelReducedClustering";
	oneReductionExperiment(resultPath, clustering, labelReducer, centroidLabeler, designation, timeStamp);

    }
    */



    /**
     * Stamps the Measures:s with the same time as a stamp.
     */
    private void calculateAndSaveEvaluation(IMatrix matrix, IObjectGrouping clustering, IObjectGrouping categorization, String resFileName, long timeStamp){

	Evaluation eval = 
	    new Evaluation(matrix, clustering, categorization, similarity, ""+timeStamp);
	    try{
		eval.setProperty("Group Evaluation", false);
	    }catch(PropertyNotFoundException pnfe){
		System.out.println("ExperimentatorReductionReduction.calculateAndSaveEvaluation():  Group Evaluation");
		System.exit(0);
	    }


	try{
	    Measures measures = eval.calculateAllMeasures();
	    measures.save(resFileName);
	}
	catch(MeasureNameConflictException mnce){
	    System.out.println("Measure Name Conflict!");
	    mnce.printStackTrace();
	    System.out.println();
	}
    }



    private void badInput(String comment){
	System.out.println("Bad input!");
	System.out.println(comment);
	System.exit(0);
    }

    
    private void checkInput(String[] args) throws IOException, SAXException, PropertyNotFoundException{

	if(args.length==0)
	    badInput("To few arguments.");



	for(int i=0; i<args.length; i++){
	    if(args[i].equals("-tokenFile")){
		setProperty("Token File", args[i+1]);
		setProperty("In File Type", 2);
		//		tokenFile=args[i+1];
	    }else if(args[i].equals("-matrix")){
		setProperty("Matrix File", args[i+1]);
		setProperty("In File Type", 0);
		//		matrixFile=args[i+1];
	    }else if(args[i].equals("-corpus")){
		setProperty("Corpus File", args[i+1]);
		setProperty("In File Type", 3);
		//		corpusFile=args[i+1];
	    }else if(args[i].equals("-inpath")){
		setProperty("Inpath", args[i+1]);
		setProperty("In File Type", 1);
		//		inpath=args[i+1];
	    }else if(args[i].equals("-iobjectGrouping")){
		setProperty("Comparison Grouping", 1);
		setProperty("IObjectGrouping File", args[i+1]);
		//		iobjectGroupingFile=args[i+1];
	    }else if(args[i].equals("-documentGrouping")){
		setProperty("Comparison Grouping", 3);
		setProperty("DocumentGrouping File", args[i+1]);
		//		documentGroupingFile=args[i+1];
	    }else if(args[i].equals("-makeIObjectGroupingFromLocation")){
		setProperty("Comparison Grouping", 2);
		//		makeIObjectGroupingFromLocation=true;
	    }else if(args[i].equals("-sve")){
		setProperty("Language", 0);
	    }else if(args[i].equals("-eng")){
		setProperty("Language", 1);
		//		language=1;
	    }else if(args[i].equals("-resultPath")){
		setProperty("Result Path", args[i+1]);
		setProperty("Experiment result type", 0);
		//		resultPath=args[i+1];
	    }else if(args[i].equals("-experimentPath")){
		setProperty("Experiment Path", args[i+1]);
	    }else if(args[i].equals("-experimentResultPath")){
		setProperty("Experiment Result Path", args[i+1]);
	    }
	}



	String experimentPath = (String) 
	    getPropertyValue("Experiment Path");
	if(experimentPath!=null){
	    PropertiesPool tempPool = new PropertiesPool();
	    tempPool.loadPropertiesInDirectory(experimentPath);
	    Properties experimentatorProperties = 
		tempPool.getPropertiesForObject(this);
	    if(experimentatorProperties==null)
		badInput("No Experimentator Properties Found!");
	    setProperties(experimentatorProperties);

	    String resultPath = (String) getPropertyValue("Experiment Result Path");

	    System.out.println("----------------------------- "+resultPath);
	    File path = new File(resultPath);
	    if(!path.exists())
		path.mkdirs();
	    tempPool.savePropertiesToDirectory(path);
	}

	experimentPath = (String) 
	    getPropertyValue("Experiment Path");
	String experimentResultPath = (String) 
	    getPropertyValue("Experiment Result Path");



	int numberOfIterations = (Integer) 
	    getPropertyValue("Number of iterations");

	int inFileType = (Integer) getPropertyValue("In File Type");
	String matrixFile = (String) getPropertyValue("Matrix File");
	String tokenFile = (String) getPropertyValue("Token File");
	String corpusFile = (String) getPropertyValue("Corpus File");
	String inpath = (String) getPropertyValue("Inpath");

	int comparisonGrouping = (Integer) 
	    getPropertyValue("Comparison Grouping");
	String documentGroupingFile = (String) 
	    getPropertyValue("DocumentGrouping File");
	String iobjectGroupingFile = (String) 
	    getPropertyValue("IObjectGrouping File");
	boolean makeIObjectGroupingFromLocation =
	    (2==comparisonGrouping);

	int language = (Integer) getPropertyValue("Language");
	String resultPath = (String) getPropertyValue("Result Path");



	if(tokenFile==null && matrixFile==null && 
	    corpusFile==null && inpath==null)
	    badInput("No input file.");


	if(resultPath==null && experimentResultPath==null)
	    badInput("No output path");
	    
    }


    private IMatrix matrix = null;
    private SparseISimilarity similarity = null;
    private IObjectGrouping categorization = null;

    private void readFiles(){

	int inFileType = (Integer) 
	    getPropertyValue("In File Type");
	String matrixFile = (String) 
	    getPropertyValue("Matrix File");
	String inpath =  (String) getPropertyValue("Inpath");
	String tokenFile =  (String) getPropertyValue("Token File");
	String corpusFile =  (String) getPropertyValue("Corpus File");
	
	int comparisonGrouping = (Integer) 
	    getPropertyValue("Comparison Grouping");
	String documentGroupingFile= (String)
	    getPropertyValue("DocumentGrouping File");
	String iobjectGroupingFile = (String) 
	    getPropertyValue("IObjectGrouping File");
	boolean makeIObjectGroupingFromLocation =
	    (2==comparisonGrouping);

	if((iobjectGroupingFile==null && documentGroupingFile==null && 
	    !makeIObjectGroupingFromLocation))
	    badInput("No comparison categorization.");

	// Lsa in matris
	if(tokenFile!=null && inFileType==2){
	    File file = new File(tokenFile);
	    TokenFileTextWordIO tokenIO = new TokenFileTextWordIO();
	    matrix = tokenIO.load(file);
	}else if(matrixFile!=null && inFileType==0){
	    File file = new File(matrixFile);
	    IMatrixIO iomatrix = new IMatrixIO();
	    matrix = iomatrix.load(file);
	}else if(corpusFile!=null && inFileType==3){
	    File file = new File(corpusFile);
	    CorpusIO ioCorpus = new CorpusIO();
	    matrix = ioCorpus.load(file);
	}else if(inpath!=null && inFileType==1){
	    File file = new File(inpath);
	    TextDirectoryReader tdr = new TextDirectoryReader();
	    matrix = tdr.load(file);
	}else
	    badInput("No input file");

	System.out.println("Opened!!!");

	IObjectGrouping rowGrouping = 
	    matrix.getColumnIObjectSet().makeStartGrouping();
	IObjectGrouping colGrouping = 
	    matrix.getRowIObjectSet().makeStartGrouping();
	rowGrouping.sort();
	colGrouping.sort();

	// Lsa in kategorisering
	if(iobjectGroupingFile!=null && comparisonGrouping==1){
	    File file = new File(iobjectGroupingFile);
	    IObjectGroupingIO iobio = new IObjectGroupingIO();
	    boolean row=true; // row categorization
	    categorization = iobio.load(row, matrix, file);
	}else if(documentGroupingFile!=null && comparisonGrouping==3){
	    File file = new File(documentGroupingFile);
	    DocumentGroupingIO dgio = new DocumentGroupingIO(matrix);//this);
	    categorization = dgio.load(file);
	}else if(makeIObjectGroupingFromLocation &&
		 (tokenFile!=null || inpath!=null) && 
		 comparisonGrouping==2){
	    LocationGrouper locationGrouper = new LocationGrouper();
	    categorization = 
		locationGrouper.cluster(matrix.getRowIObjectSet());
	}else
	    badInput("No categorization");
	categorization.sort();
	matrix.getRowIObjectSet().addGrouping(categorization);
	System.out.print("Categorization: ");
	categorization.printGroupSizes();
	System.out.println("Preprocessed!!!");
    }

    private void stoplist(){

	int language = (Integer) getPropertyValue("Language");

	// Preprocessing
	String stoplistFileName = sweStoplistFileName;
	if(language==1) // engelska
	    stoplistFileName = engStoplistFileName;
	Stoplist sl = new Stoplist(stoplistFileName);
	boolean row=true;
	sl.removeIObjectsInStoplist(matrix, row);
    }

    private void filter(){
	IMatrixCellFilter matrixCellFilter = new IMatrixCellFilter();
	Properties p = pp.getPropertiesForObject(matrixCellFilter);
	if(p!=null)
	    matrixCellFilter.setProperties(p);
	System.out.println(matrix + ", " + matrixCellFilter);
	matrixCellFilter.filter(matrix);
    }


    // OBS tar den sista av de Weighter:s som finns.
    private Weighter weight(){

	Vector<Properties> props = 
	    pp.getPropertiesWithSuperClassName("infomat.vectorspace.weighting.Weighter");
	Weighter weighter = null;
	for(int i=0; i<props.size(); i++){
	    Properties p = props.elementAt(i);
	    String className = p.getOwnerClassName();
	    System.out.println("Weighter : "+className);
	    try{
		Class c = Class.forName(className);
		weighter = (Weighter) c.newInstance();
		weighter.setProperties(p);

		System.out.println("Weighter : "+className);
	    }catch(ClassNotFoundException cnfe){
		// Do nothing
		System.out.println("ClassNotFoundException cnfe){");
	    }catch(InstantiationException ie){
		// Do nothing
		System.out.println("InstantiationException ie){");
	    }catch(IllegalAccessException iae){
		// Do nothing
		System.out.println("IllegalAccessException iae){");
	    }
	}

	weighter.weight(matrix);
	return weighter;
    }


}
