package infomat.mro.risynlexeval;

import infomat.algorithms.grouping.*;
import infomat.algorithms.projection.*;
import infomat.bridges.jsdm.*;
import infomat.evaluation.*;
import infomat.vectorspace.*;
import infomat.vectorspace.similarity.*;
import infomat.vectorspace.vector.*;
import infomat.vectorspace.weighting.*;
import infomat.mro.synlex.*;

import mro.util.doublehashmap.*;
import mro.util.measures.*;
import mro.util.properties.*;

import java.io.*;
import java.util.*;




/*

java -cp .:classes/:lib/sdm.jar -Xms1500m -Xmx1500m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex-500-4-SUPERHUGEcontextwindowCONSTANT /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/500-4-SUPERHUGEcontextwindowCONSTANT/

java -cp .:classes/:lib/sdm.jar -Xms2500m -Xmx2500m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex-1000-4-SUPERHUGEcontextwindowCONSTANT /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/1000-4-SUPERHUGEcontextwindowCONSTANT/ 

java -cp .:classes/:lib/sdm.jar -Xms3000m -Xmx3000m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex-1800-4-SUPERHUGEcontextwindowCONSTANT /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/1800-4-SUPERHUGEcontextwindowCONSTANT/



***********

java -cp .:classes/:lib/sdm.jar -Xms2500m -Xmx2500m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex1800-4 /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/graded-1800-4/

java -cp .:classes/:lib/sdm.jar -Xms2500m -Xmx2500m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex-dok-1800-4 /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/graded-dok-1800-4/


***********

java -cp .:classes/:lib/sdm.jar -Xms2500m -Xmx2500m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex1800-4 /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/new1800-4/

***********


java -cp .:classes/:lib/sdm.jar -Xms1000m -Xmx1000m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex-500-4-HUGEcontextwindow /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/500-4-HUGEcontextwindow/

java -cp .:classes/:lib/sdm.jar -Xms2000m -Xmx2000m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex-1000-4-HUGEcontextwindow /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/1000-4-HUGEcontextwindow/ 

java -cp .:classes/:lib/sdm.jar -Xms2500m -Xmx2500m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex-1800-4-HUGEcontextwindow /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/1800-4-HUGEcontextwindow/


***********


java -cp .:classes/:lib/sdm.jar -Xms1000m -Xmx1000m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex-500-4-HUGEcontextwindowCONSTANT /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/500-4-HUGEcontextwindowCONSTANT/

java -cp .:classes/:lib/sdm.jar -Xms2000m -Xmx2000m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex-1000-4-HUGEcontextwindowCONSTANT /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/1000-4-HUGEcontextwindowCONSTANT/ 

java -cp .:classes/:lib/sdm.jar -Xms2500m -Xmx2500m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex-1800-4-HUGEcontextwindowCONSTANT /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/1800-4-HUGEcontextwindowCONSTANT/


***********

java -cp .:classes/:lib/sdm.jar -Xms1000m -Xmx1000m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex-500-4-largecontextwindowCONSTANT /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/500-4-largecontextwindowCONSTANT/

java -cp .:classes/:lib/sdm.jar -Xms2000m -Xmx2000m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex-1000-4-largecontextwindowCONSTANT /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/1000-4-largecontextwindowCONSTANT/ 

java -cp .:classes/:lib/sdm.jar -Xms2500m -Xmx2500m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex-1800-4-largecontextwindowCONSTANT /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/1800-4-largecontextwindowCONSTANT/

***********

java -cp .:classes/:lib/sdm.jar -Xms1000m -Xmx1000m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex500-4 /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/500-4/ &

java -cp .:classes/:lib/sdm.jar -Xms1000m -Xmx1000m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex-dok-500-4 /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/dok-500-4/ & 

java -cp .:classes/:lib/sdm.jar -Xms1000m -Xmx1000m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex-dok-500-4orlessonly /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/dok-500-4orlessonly/ &

java -cp .:classes/:lib/sdm.jar -Xms1000m -Xmx1000m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex-500-4orlessonly /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/500-4orlessonly/ &

java -cp .:classes/:lib/sdm.jar -Xms1000m -Xmx1000m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex-500-4-largecontextwindow /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/500-4-largecontextwindow/ &





***********

java -cp .:classes/:lib/sdm.jar -Xms2500m -Xmx2500m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex1800-4 /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/1800-4/ &

java -cp .:classes/:lib/sdm.jar -Xms2500m -Xmx2500m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex-dok-1800-4 /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/dok-1800-4/ & 

java -cp .:classes/:lib/sdm.jar -Xms2500m -Xmx2500m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex-dok-1800-4orlessonly /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/dok-1800-4orlessonly/ &

java -cp .:classes/:lib/sdm.jar -Xms2500m -Xmx2500m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex-1800-4orlessonly /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/1800-4orlessonly/ &

java -cp .:classes/:lib/sdm.jar -Xms2500m -Xmx2500m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex-1800-4-largecontextwindow /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/1800-4-largecontextwindow/ &



***********


java -cp .:classes/:lib/sdm.jar -Xms1024m -Xmx1024m infomat.mro.risynlexeval.RISynlexEval <synlex> <ri> <resultPath>

java -cp .:classes/:lib/sdm.jar -Xms1024m -Xmx1024m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/testJtteliten.xml /afs/nada.kth.se/misc/tcs/language/vol/5/KTHNC/pre/RIjtteLitenPre /afs/nada.kth.se/home/f/u1ya3frf/Code/tmp/riResult/

java -cp .:classes/:lib/sdm.jar -Xms1024m -Xmx1024m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/misc/tcs/language/vol/5/KTHNC/pre/RIA1pre /afs/nada.kth.se/home/f/u1ya3frf/Code/tmp/riResult/


***********


java -cp .:classes/:lib/sdm.jar -Xms3024m -Xmx3024m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex1 /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/first/

java -cp .:classes/:lib/sdm.jar -Xms1700m -Xmx1700m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex1000-4 /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/first/1000-4/

************

java -cp .:classes/:lib/sdm.jar -Xms1000m -Xmx1000m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex500-4 /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/500-4/

***

java -cp .:classes/:lib/sdm.jar -Xms2500m -Xmx2500m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex1000-2 /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/1000-2/

java -cp .:classes/:lib/sdm.jar -Xms2000m -Xmx2000m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex1000-4 /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/1000-4/

***

java -cp .:classes/:lib/sdm.jar -Xms3024m -Xmx3024m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex1800-2 /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/1800-2/

java -cp .:classes/:lib/sdm.jar -Xms2500m -Xmx2500m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex1800-4 /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/1800-4/


************

java -cp .:classes/:lib/sdm.jar -Xms1000m -Xmx1000m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex-dok-500-4 /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/dok-500-4/

***

java -cp .:classes/:lib/sdm.jar -Xms2500m -Xmx2500m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex-dok-1000-2 /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/dok-1000-2/

java -cp .:classes/:lib/sdm.jar -Xms2000m -Xmx2000m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex-dok-1000-4 /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/dok-1000-4/

***

java -cp .:classes/:lib/sdm.jar -Xms3024m -Xmx3024m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex-dok-1800-2 /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/dok-1800-2/

java -cp .:classes/:lib/sdm.jar -Xms2500m -Xmx2500m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex-dok-1800-4 /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/dok-1800-4/


***


java -cp .:classes/:lib/sdm.jar -Xms1000m -Xmx1000m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex-dok-500-4orlessonly /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/dok-500-4orlessonly/

java -cp .:classes/:lib/sdm.jar -Xms2000m -Xmx2000m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex-dok-1000-4orlessonly /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/dok-1000-4orlessonly/

java -cp .:classes/:lib/sdm.jar -Xms2500m -Xmx2500m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex-dok-1800-4orlessonly /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/dok-1800-4orlessonly/

***

java -cp .:classes/:lib/sdm.jar -Xms1500m -Xmx1500m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex-500-4orlessonly /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/500-4orlessonly/

java -cp .:classes/:lib/sdm.jar -Xms2000m -Xmx2000m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex-1000-4orlessonly /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/1000-4orlessonly/

java -cp .:classes/:lib/sdm.jar -Xms2500m -Xmx2500m infomat.mro.risynlexeval.RISynlexEval /afs/nada.kth.se/home/f/u1ya3frf/Ordlistor/synlex/synpairs.xml /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/risynlex-1800-4orlessonly /afs/nada.kth.se/home/f/u1ya3frf/RISYNLEX/eval/1800-4orlessonly/





*/




/****************/



/**
 *
 * <br>
 * <br>
 * <code>javac -classpath ./classes/:lib/sdm.jar -sourcepath ./src ./src/infomat/mro/risynlexeval/*.java -d classes</code> 
 *
 * <br>
 * <br>
 * <code>java -cp .:classes/:lib/sdm.jar -Xms1024m -Xmx1024m infomat.mro.risynlexeval.RISynlexEval</code>
 *
 *
 * @version          
 * @author           Magnus Rosell
 *
 */

public class RISynlexEval{

    public static void main(String[] args) throws IOException{

	if(args.length!=3){
	    System.out.println("Fel input!");
	    System.exit(0);
	}
	String synlexFileName = args[0];
	String riFileName = args[1];
	String resultPath = args[2];
	


	/****** Synlex ******/

	File synlexFile = new File(synlexFileName);
	SynlexIO sio = new SynlexIO();
	IMatrix synlexMatrix = sio.load(synlexFile);

	System.out.println("synlex matrix: "+synlexMatrix.getNumberOfRowsColumnsCellsString());

	IObjectSet synSet = synlexMatrix.getRowIObjectSet();

	IVector<IMatrixCell> synlexIV = 
	    synlexMatrix.getIVectorOfElements();

	/*
	findNumOfIObjectInIMatrixIVector(synlexIV);
	System.exit(0);
	*/

	/*
	findUnsymmetricCellsInIVector(synlexIV);
	System.exit(0);
	*/

	System.out.println("synlexIV: "+synlexIV.size());
	removeSymmetricCellsFromIVector(synlexIV);
	System.out.println("synlexIV: "+synlexIV.size());

	/****** Syntest ******/

	String syntestFileName = "/afs/nada.kth.se/misc/info/DH2418/sprakt07/ri/randomindexing/test1.dat";
	Syntest syntest = new Syntest();
	syntest.readTest(syntestFileName);
	

	/****** RI ******/

	RIIO riio = new RIIO();

	JSDMWrapper jsdmw = new JSDMWrapper();
	jsdmw.load(riFileName, synSet);
	JSDMSimilarity jsdmSIM = new JSDMSimilarity(jsdmw);


	/**** RI-Synlex-Measures ****/

	long time = System.currentTimeMillis();
	//	Measures riSynlexMeasures = new Measures("RI evaluated against The People's Dictionary of Synonyms");


	/**** Evaluation sim - synlex ****/

	/*
	double simMin = 0.2;
	double simMax = 1.0;
	double synlexMin = 3.0;
	double synlexMax = 5.0;
	double corrcoeff = 
	    simSynlexCorrelation(jsdmSIM, simMin, simMax, synlexIV, synlexMin, synlexMax);

	System.out.println("corr coeff: "+ corrcoeff);
	*/

	/*
	try{
	    String groupName = "Original RI";
	    System.out.println(groupName+" Correlation Evaluation");

	    MeasureGroup mg = 
		correlationEvaluation(jsdmSIM, synlexIV, groupName);
	    riSynlexMeasures.addMeasure(mg);

	    System.out.println(groupName+" Correlation Evaluation. Done.");
	}catch(MeasureNameConflictException mnce){
	    System.out.println("MeasureNameConflictException for Original RI");
	}

	riSynlexMeasures.setAllMeasuresStampsRecursively(""+time);
	String correlationEvaluationFileName = resultPath+"/correlation/original/riCorrelationEvaluation"+time+".xml";
	riSynlexMeasures.save(correlationEvaluationFileName);
	*/

	IObjectGroup fullGroup = jsdmw.getFullIObjectGroup();

	String groupName = "Original RI";
	String resPath = resultPath+"/correlation/original/";
	evaluateAndSave(jsdmSIM, synlexIV, syntest, fullGroup, 
			groupName, resPath, time);




	/**** Clustering ****/
	System.out.println("fullGroup: "+fullGroup.numberOfIObjects());

	//	GroupingAlgorithm alg = new BisectingKMeans(jsdmSIM);
	GroupingAlgorithm alg = new KMeans(jsdmSIM);
	RandomClusterer rndClusterer = new RandomClusterer();

	//	int[] differentClusters = {100, 200, 300};
	//	int[] differentClusters = {5, 10, 100, 200, 300};
	int[] differentClusters = {5, 10};
	//	int[] differentClusters = {5, 10};
	for(int c = 0; c<differentClusters.length; c++){

	    int numberOfClusters = differentClusters[c];
	    try{
		rndClusterer.setProperty("Number of clusters", numberOfClusters);
		alg.setProperty("Repeat number of times", 20);
		alg.setProperty("Number of clusters", numberOfClusters);
		System.out.println("************************************************");
		System.out.println("Number of clusters: "+numberOfClusters);
	    }catch(PropertyNotFoundException pnfe){
		// Do nothing
	    }

	    int repeat = 10;

	    // Random Clustering
	    for(int r=0; r<repeat; r++){
		System.out.println("********** Random Clustering "+numberOfClusters+" clusters, repeat "+r);
		IObjectGrouping clustering = rndClusterer.cluster(fullGroup);
		clustering.removeEmptyGroups();
		
		evalClustering(clustering, jsdmSIM, synlexIV, resultPath+"/"+numberOfClusters+"cluster/random/", time);
	    }
	    
	    // K-Means Clustering
	    IObjectGrouping bestClustering = null;
	    double bestValue = -Double.MAX_VALUE;
	    for(int r=0; r<repeat; r++){
		System.out.println("********** K-Means "+numberOfClusters+" clusters, repeat "+r);
		
		IObjectGrouping clustering = alg.cluster(fullGroup);
		clustering.removeEmptyGroups();
		
		Measures measures = evalClustering(clustering, jsdmSIM, synlexIV, resultPath+"/"+numberOfClusters+"cluster/K-Means/", time);
		
		MeasureGroup mg = measures.getMeasureGroup("Intrinsic Measures");
		mg = mg.getMeasureGroup("Evaluated Grouping");
		Measure m = mg.getMeasure("Weighted Avereage Self Similarity");
		if(m.getValue()>bestValue){
		    bestValue=m.getValue();
		    bestClustering = clustering;
		}
		
		
	    }
	    
	    /**** Project ****/
	    /*
	    System.out.println(" *** Projection!");
	    
	    ProjectionSimilarity projSIM = 
		Projector.project(bestClustering, bestClustering, jsdmSIM);
	    projSIM.normalizeAll();
	    
	    groupName = ""+numberOfClusters+" clusters RI";
	    resPath = resultPath+"/correlation/"+numberOfClusters+"clusters/";
	    evaluateAndSave(projSIM, synlexIV, syntest, fullGroup, 
			    groupName, resPath, time);
	    */

	}



    }





    public static Measures evalClustering(IObjectGrouping clustering, DenseISimilarity similarity, IVector<IMatrixCell> correctPairs, String resultPath, long time){

	/*
	String resultFileName = 
	    resultPath+"clusteringResult."+time+".xml";
	File resFile = new File(resultFileName);
	//	GroupingTextIO gtio = new GroupingTextIO();
	IObjectGroupingTextResult gtio = new IObjectGroupingTextResult();
	IMatrix matrix = null;
	gtio.save(matrix, clustering, jsdmSim, resFile);

	System.out.println("Sparat resultat textuellt");
	*/

	// Evaluate and write the results

	long thisTime = System.currentTimeMillis();

	String evaluationFileName = 
	    resultPath+"clusteringEvaluation."+time+"."+thisTime+".xml";
	Evaluation eval = 
	    new Evaluation(null, clustering, similarity, ""+thisTime);
	try{
	    eval.setProperty("Group Evaluation", false);
	}catch(PropertyNotFoundException pnfe){
	    // Do nothing.
	}


	Measures measures = new Measures("Measures");
	try{
	    measures = eval.calculateAllMeasures();
	}
	catch(MeasureNameConflictException mnce){
	    System.out.println("Measure Name Conflict!");
	}

	try{
	    // 3.0
	    ExtrinsicPairEvaluation epe = new ExtrinsicPairEvaluation();
	    MeasureGroup mg = 
		epe.allMeasuresInAGroup(clustering, correctPairs);
	    measures.addMeasure(mg);

	    // 4.0
	    double val = 4.0;
	    IVector<IMatrixCell> ivec = correctPairs.largerThanOrEquals(val);
	    mg = 
		epe.allMeasuresInAGroup(clustering, ivec);
	    mg.setName(mg.getName()+" "+val);
	    measures.addMeasure(mg);

	    // 5.0
	    val = 5.0;
	    ivec = correctPairs.largerThanOrEquals(val);
	    mg = 
		epe.allMeasuresInAGroup(clustering, ivec);
	    mg.setName(mg.getName()+" "+val);
	    measures.addMeasure(mg);

	}
	catch(MeasureNameConflictException mnce){
	    System.out.println("Measure Name Conflict Adding ExtrinsicPairEvaluation!");
	}

	measures.setAllMeasuresStampsRecursively(""+time);

	measures.save(evaluationFileName);

	return measures;
    }



    public static void 
	evaluateAndSave(DenseISimilarity similarity, 
			IVector<IMatrixCell> synlexIV,
			Syntest syntest, 
			IObjectGroup fullGroup, 
			String groupName,
			String resultPath,
			long time){
	
	//	int repeat = 3;
	//	for(int r = 1; r<=repeat; r++){

	    Measures riSynlexMeasures = new Measures("RI evaluated against The People's Dictionary of Synonyms");
	    
	    try{
		System.out.println(groupName+" Evaluation");
		
		MeasureGroup mg = 
		    syntest.test(similarity, fullGroup, "Synonymy test");
		
		riSynlexMeasures.addMeasure(mg);
		
		mg = 
		    correlationEvaluation(similarity, synlexIV, "Correlation");//groupName);
		riSynlexMeasures.addMeasure(mg);
		
		System.out.println(groupName+" Evaluation. Done.");
	    }catch(MeasureNameConflictException mnce){
		System.out.println("MeasureNameConflictException for Original RI");
	    }
	    
	    riSynlexMeasures.setAllMeasuresStampsRecursively(""+time);
	    //	    String correlationEvaluationFileName = resultPath+"evalNR"+r+"/riCorrelationEvaluation."+time+".xml";
	    String correlationEvaluationFileName = resultPath+"riCorrelationEvaluation."+time+".xml";
	    riSynlexMeasures.save(correlationEvaluationFileName);

	    //	}
    }








    public static MeasureGroup 
	correlationEvaluation(DenseISimilarity similarity, 
			      IVector<IMatrixCell> synlexIV,
			      String groupName){
	
	MeasureGroup mg = new MeasureGroup(groupName);

	double[] simMins = {0.0, 0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9};
	double[] simMaxs = {0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1.0};
	double[] synlexMins = {3.0, 3.5, 4.0, 4.5, 5.0};
	double[] synlexMaxs = {3.0, 3.5, 4.0, 4.5, 5.0};

	int number = simMins.length * simMaxs.length * 
	    synlexMins.length * synlexMaxs.length;

	for(int i=0; i<simMins.length; i++){
	    double simMin = simMins[i];
	    for(int j=0; j<simMaxs.length; j++){
		double simMax = simMaxs[j];

		System.out.print(number +", ");
		if(simMin>=simMax){
		    number -= synlexMins.length*synlexMaxs.length;
		    continue;
		}

		for(int k=0; k<synlexMins.length; k++){
		    double synlexMin = synlexMins[k];
		    for(int l=0; l<synlexMaxs.length; l++){
			
			number--;

			double synlexMax = synlexMaxs[l];
			if(synlexMin>=synlexMax)
			    continue;

			/*
			double corr = simSynlexCorrelation(similarity, 
							   simMin,
							   simMax, 
							   synlexIV,
							   synlexMin,
							   synlexMax);
			*/

			double corr = 0.0;
			double rho = 0.0;
			double rhoStudent = 0.0;
			IVector<IMatrixCell> riVec = 
			    new IVector<IMatrixCell>();
			IVector<IMatrixCell> tmpSynlexIV = 
			    synlexIV.largerThanOrEquals(synlexMin);
			if(tmpSynlexIV.size()>0){
			    tmpSynlexIV = 
				tmpSynlexIV.smallerThanOrEquals(synlexMax);
			    if(tmpSynlexIV.size()>0){
				riVec = constructRIIVector(tmpSynlexIV, similarity);
				//				System.out.println("riVec: "+riVec.size());


				if(riVec.size()>0){
				    riVec = riVec.largerThanOrEquals(simMin);
				    //				    System.out.println("riVec: "+riVec.size());
				    if(riVec.size()>0){
					riVec = riVec.smallerThanOrEquals(simMax);
					//					System.out.println("riVec: "+riVec.size());
					if(riVec.size()>0){
					    fitIVectors(tmpSynlexIV, riVec);
					    if(riVec.size()>0){

						// Correlation
						corr = IVector.corrCoeff(tmpSynlexIV, riVec);
						//						corr = correlationCoefficient(tmpSynlexIV, riVec);
						//						corr = stableCorrelation(tmpSynlexIV, riVec);
						//						corr = correlationCoefficientSizeOrder(tmpSynlexIV, riVec);
						//						corr = correlationSizeOrder(tmpSynlexIV, riVec);

						// Spearmans rank correlation
						rho = spearmans(tmpSynlexIV, riVec);

						double denomNom = 1-Math.pow(rho,2);
						if(denomNom!=0)
						    rhoStudent = rho/(Math.sqrt(denomNom/(riVec.size()-2)));

					    }
					}
				    }
				}
			    }
			}

			try{
			    Measure m = new Measure("RI=["+simMin+", "+simMax+"], dict=["+synlexMin+", "+synlexMax+"]", 0.0, "RI=["+simMin+", "+simMax+"], dict=["+synlexMin+", "+synlexMax+"]");

			    mg.addMeasure(m);


			    m = new Measure("corrcoeff (RI=["+simMin+", "+simMax+"], dict=["+synlexMin+", "+synlexMax+"])", corr, "corrcoeff (RI=["+simMin+", "+simMax+"], dict=["+synlexMin+", "+synlexMax+"])");

			    mg.addMeasure(m);

			    m = new Measure("rho (RI=["+simMin+", "+simMax+"], dict=["+synlexMin+", "+synlexMax+"])", rho, "rho (RI=["+simMin+", "+simMax+"], dict=["+synlexMin+", "+synlexMax+"])");

			    mg.addMeasure(m);

			    m = new Measure("rho Student (RI=["+simMin+", "+simMax+"], dict=["+synlexMin+", "+synlexMax+"])", rhoStudent, "rho Student (RI=["+simMin+", "+simMax+"], dict=["+synlexMin+", "+synlexMax+"])");

			    mg.addMeasure(m);

			    m = new Measure("syn pairs (RI=["+simMin+", "+simMax+"], dict=["+synlexMin+", "+synlexMax+"])", riVec.size(), "syn pairs (RI=["+simMin+", "+simMax+"], dict=["+synlexMin+", "+synlexMax+"])");

			    mg.addMeasure(m);
			}catch(MeasureNameConflictException mnce){
			    System.out.println("MeasureNameConflictException for "+"corrcoeff (RI=["+simMin+", "+simMax+"], dict=["+synlexMin+", "+synlexMax+"])");
			}

		    }
		}
	    }
	}

	System.out.println();
	
	return mg;

    }



    public static void convertToRank(IVector<IMatrixCell> ivec){
	Vector<IMatrixCell> vec = ivec.getOrderedVector();
	IMatrixCell mc = vec.get(0);
	float previousValue = ivec.getValue(mc);
	float rank = vec.size();
	HashMap<IMatrixCell, Float> same = new HashMap<IMatrixCell, Float>();
	same.put(mc, rank);

	for(int i=1; i<vec.size(); i++){
	    mc = vec.get(i);
	    float value = ivec.getValue(mc);
	    rank = vec.size()-i;
	    if(value==previousValue){
		same.put(mc, rank);
	    }else{
		float newrank = 0.0f;
		Iterator<Float> it = same.values().iterator();
		while(it.hasNext()){
		    newrank += it.next();
		}
		newrank /= same.size();
		
		Iterator<IMatrixCell> it2 = same.keySet().iterator();
		while(it2.hasNext()){
		    IMatrixCell mc2 = it2.next();
		    ivec.put(mc2, newrank);
		}

		same = new HashMap<IMatrixCell, Float>();
		same.put(mc, rank);
	    }

	    previousValue = value;
	}

	if(same.size()>0){
	    float newrank = 0.0f;
	    Iterator<Float> it = same.values().iterator();
	    while(it.hasNext()){
		newrank += it.next();
	    }
	    newrank /= same.size();
	    
	    Iterator<IMatrixCell> it2 = same.keySet().iterator();
	    while(it2.hasNext()){
		IMatrixCell mc2 = it2.next();
		ivec.put(mc2, newrank);
	    }
	}


    }

    public static double spearmans(IVector<IMatrixCell> tmpSynlexIV, 
				   IVector<IMatrixCell> riVec){
	convertToRank(tmpSynlexIV);
	convertToRank(riVec);
	return IVector.corrCoeff(tmpSynlexIV, riVec);
	//	return spearmansHelper(tmpSynlexIV, riVec);
	//	return correlationCoefficient(tmpSynlexIV, riVec);
	//	return correlation(tmpSynlexIV, riVec);
	//	return stableCorrelation(tmpSynlexIV, riVec);
	//	return correlationCoefficientSizeOrder(tmpSynlexIV, riVec);
	//	return correlationSizeOrder(tmpSynlexIV, riVec);

    }

    private static double correlationSizeOrder(IVector<IMatrixCell> ivec1, 
					       IVector<IMatrixCell> ivec2){
	double mean1 = ivec1.mean();
	double mean2 = ivec2.mean();
	double std1 = ivec1.std();
	double std2 = ivec2.std();

	IVector<IMatrixCell> termIvec = new IVector<IMatrixCell>();

	Vector<IMatrixCell> vec1 = ivec1.getUnorderedVector();
	for(int i=0; i<vec1.size(); i++){
	    IMatrixCell mc1 = vec1.get(i);
	    double weight1 = ivec1.getValue(mc1);
	    double weight2 = ivec2.getValue(mc1);

	    double p1 = (weight1-mean1)/std1;
	    double p2 = (weight2-mean2)/std2;

	    termIvec.put(mc1, (float) (p1*p2));
	}

	double corr = 0.0;
	Vector<IMatrixCell> termVec = termIvec.getOrderedVector();
	for(int i=termVec.size()-1; i>=0; i--){
	    IMatrixCell mc = termVec.get(i);
	    double term = termIvec.getValue(mc);
	    corr += term;
	}

	return corr;
    }




    /*
sum_sq_x = 0
 sum_sq_y = 0
 sum_coproduct = 0
 mean_x = x[1]
 mean_y = y[1]
 for i in 2 to N:
     sweep = (i - 1.0) / i
     delta_x = x[i] - mean_x
     delta_y = y[i] - mean_y
     sum_sq_x += delta_x * delta_x * sweep
     sum_sq_y += delta_y * delta_y * sweep
     sum_coproduct += delta_x * delta_y * sweep
     mean_x += delta_x / i
     mean_y += delta_y / i 
 pop_sd_x = sqrt( sum_sq_x )
 pop_sd_y = sqrt( sum_sq_y )
 cov_x_y = sum_coproduct
 correlation = cov_x_y / (pop_sd_x * pop_sd_y)
    */

    private static double stableCorrelation(IVector<IMatrixCell> ivec1, 
					    IVector<IMatrixCell> ivec2){
	Vector<IMatrixCell> vec1 = ivec1.getUnorderedVector();
	int n = ivec1.size();
	double sum_sq_x = 0;
	double sum_sq_y = 0;
	double cov_x_y = 0;

	IMatrixCell mc = vec1.get(0);
	double mean_x = ivec1.getValue(mc);
	double mean_y = ivec2.getValue(mc);
	for(int i=1; i<n; i++){
	    int j = i+1;
	    double sweep = (j-1.0)/j;
	    mc = vec1.get(i);
	    double delta_x = ivec1.getValue(mc) - mean_x;
	    double delta_y = ivec2.getValue(mc) - mean_y;
	    sum_sq_x += delta_x * delta_x * sweep;
	    sum_sq_y += delta_y * delta_y * sweep;
	    cov_x_y = delta_x * delta_y * sweep;
	    mean_x += delta_x/j;
	    mean_y += delta_y/j;
	}

	return cov_x_y / (Math.sqrt(sum_sq_x) * Math.sqrt(sum_sq_y));
    }

    private static double correlationCoefficientSizeOrder(IVector<IMatrixCell> ivec1, 
							  IVector<IMatrixCell> ivec2){
	IVector<IMatrixCell> xyIvec = new IVector<IMatrixCell>();

	Vector<IMatrixCell> vec1 = ivec1.getOrderedVector();
	double x = 0.0;
	double x2 = 0.0;
	for(int i=vec1.size()-1; i>=0; i--){
	    IMatrixCell mc1 = vec1.get(i);
	    double weight1 = ivec1.getValue(mc1);
	    x += weight1;
	    x2 += Math.pow(weight1, 2);

	    double weight2 = ivec2.getValue(mc1);
	    xyIvec.put(mc1, (float) (weight1 * weight2));
	}

	Vector<IMatrixCell> vec2 = ivec2.getOrderedVector();
	double y = 0.0;
	double y2 = 0.0;
	for(int i=vec2.size()-1; i>=0; i--){
	    IMatrixCell mc2 = vec2.get(i);
	    double weight2 = ivec2.getValue(mc2);
	    y += weight2;
	    y2 += Math.pow(weight2, 2);
	}


	Vector<IMatrixCell> xyVec = xyIvec.getOrderedVector();
	double xy = 0.0;
	for(int i=xyVec.size()-1; i>=0; i--){
	    IMatrixCell mc = xyVec.get(i);
	    double weight = xyIvec.getValue(mc);
	    xy += weight;
	}



	int n = ivec1.size();

	return (n*xy - x*y)/ ( Math.sqrt(n*x2 - Math.pow(x, 2)) *
			       Math.sqrt(n*y2 - Math.pow(y, 2)));
    }


    private static double correlationCoefficient(IVector<IMatrixCell> ivec1, 
						 IVector<IMatrixCell> ivec2){
	Vector<IMatrixCell> vec1 = ivec1.getUnorderedVector();
	//	Vector<IMatrixCell> vec2 = ivec2.getUnorderedVector();
	double x = 0.0;
	double y = 0.0;
	double x2 = 0.0;
	double y2 = 0.0;
	double xy = 0.0;
	for(int i=0; i<vec1.size(); i++){
	    IMatrixCell mc1 = vec1.get(i);
	    double weight1 = ivec1.getValue(mc1);
	    double weight2 = ivec2.getValue(mc1);
	    x += weight1;
	    y += weight2;
	    x2 += Math.pow(weight1, 2);
	    y2 += Math.pow(weight2, 2);
	    xy += weight1 * weight2;
	}

	int n = ivec1.size();

	return (n*xy - x*y)/ ( Math.sqrt(n*x2 - Math.pow(x, 2)) *
			       Math.sqrt(n*y2 - Math.pow(y, 2)));
    }

    /*
    private static double spearmansHelper(IVector<IMatrixCell> ivec1, 
					  IVector<IMatrixCell> ivec2){
	Vector<IMatrixCell> vec1 = ivec1.getUnorderedVector();
	double x2 = 0.0;
	for(int i=0; i<vec1.size(); i++){
	    x2 += Math.pow(vec1.get(i).getWeight(), 2);
	}

	Vector<IMatrixCell> vec2 = ivec2.getUnorderedVector();
	double y2 = 0.0;
	for(int i=0; i<vec2.size(); i++){
	    y2 += Math.pow(vec2.get(i).getWeight(), 2);
	}
	
	double diff = 0.0;
	for(int i=0; i<vec1.size(); i++){
	    diff += Math.pow((vec1.get(i).getWeight() - vec2.get(i).getWeight()), 2);
	}
	
	return (x2 + y2 - diff)/(2*Math.sqrt(x2*y2));
    }
    */


    /*
    public static double simSynlexCorrelation(DenseISimilarity similarity, 
					      double simMin,
					      double simMax, 
					      IVector<IMatrixCell> synlexIV,
					      double synlexMin,
					      double synlexMax){



	//	System.out.println("synlexIV: "+synlexIV.size());
	synlexIV = synlexIV.largerThanOrEquals(synlexMin);
	//	System.out.println("synlexIV: "+synlexIV.size());
	synlexIV = synlexIV.smallerThanOrEquals(synlexMax);
	//	System.out.println("synlexIV: "+synlexIV.size());

	IVector<IMatrixCell> riVec = 
	    constructRIIVector(synlexIV, similarity);



	//	System.out.println("riVec: "+riVec.size());
	riVec = riVec.largerThanOrEquals(simMin);
	//	System.out.println("riVec: "+riVec.size());
	riVec = riVec.smallerThanOrEquals(simMax);
	//	System.out.println("riVec: "+riVec.size());


	fitIVectors(synlexIV, riVec);
	
	//	printIVectors(synlexIV, riVec);


	System.out.println("synlexIV: "+synlexIV.size());
	System.out.println("riVec: "+riVec.size());

	return IVector.corrCoeff(synlexIV, riVec);

    }
    */

    private static IVector<IMatrixCell> constructRIIVector(IVector<IMatrixCell> synlexIV, DenseISimilarity similarity){

	//	int count = 0;
	IVector<IMatrixCell> riVec = new IVector<IMatrixCell>();
	Vector<IMatrixCell> synVec = synlexIV.getUnorderedVector();
	for(int i=0; i<synVec.size(); i++){
	    IMatrixCell mc = synVec.get(i);
	    IObject rowObject = mc.getRowIObject();
	    IObject colObject = mc.getColumnIObject();
	    //	    System.out.println(rowObject.getString()+", "+colObject.getString()+": "+mc.getWeight());

	    /*	    
	    float sim = similarity.sim(rowObject, colObject);
	    //	    System.out.println("   -> "+sim);

	    if(sim!=0.0f)
		riVec.add(mc, sim);
	    */

	    float[] rowRepr = similarity.getRepresentation(rowObject);
	    if(rowRepr!=null){
		float[] colRepr = similarity.getRepresentation(colObject);
		if(colRepr!=null){
		    float sim = similarity.sim(rowRepr, colRepr);
		    riVec.add(mc, sim);
		}
	    }

		
	}
	
	//	System.out.println("count: "+count);

	return riVec;
    }




    private static void fitIVectors(IVector<IMatrixCell> ivec1, 
				    IVector<IMatrixCell> ivec2){
	
	//	System.out.println("ivec1: "+ivec1.size());
	//	System.out.println("ivec2: "+ivec2.size());

	fitFirstToSecondIVector(ivec1, ivec2); 
	fitFirstToSecondIVector(ivec2, ivec1); 
    }

    private static void fitFirstToSecondIVector(IVector<IMatrixCell> ivec1, 
						IVector<IMatrixCell> ivec2){
	Vector<IMatrixCell> remove1 = new Vector<IMatrixCell>();

	Vector<IMatrixCell> vec1 = ivec1.getUnorderedVector();
	for(int i = 0; i<vec1.size(); i++){
	    IMatrixCell mc = vec1.get(i);
	    Float f = ivec2.getValue(mc);
	    if(f==null)
		remove1.add(mc);
	}
	for(int i = 0; i<remove1.size(); i++){
	    IMatrixCell mc = remove1.get(i);
	    ivec1.remove(mc);
	}
    }

    private static void printIVectors(IVector<IMatrixCell> ivec1, 
				      IVector<IMatrixCell> ivec2){
	
	Vector<IMatrixCell> vec1 = ivec1.getOrderedVector();
	for(int i = 0; i<vec1.size(); i++){
	    IMatrixCell mc = vec1.get(i);
	    System.out.print(mc.getString()+": ");
	    System.out.println(ivec1.getValue(mc)+", "+ivec2.getValue(mc));
	}

    }
	
    private static void reduceSymmetricMatrix(IMatrix matrix){
	Vector<IMatrixCell> remove = new Vector<IMatrixCell>();
	Vector cells = matrix.getAllCells();
	for(int i=0; i<cells.size(); i++){
	    IMatrixCell mc = (IMatrixCell) cells.get(i);
	    IMatrixCell omc = 
		matrix.getCell(mc.getColumnIObject(), mc.getRowIObject());
	    if(omc!=null)
		remove.add(omc);
	}

	for(int i=0; i<remove.size(); i++){
	    IMatrixCell mc = remove.get(i);
	    matrix.removeCell(mc);
	}
	
    }

    private static void removeSymmetricCellsFromIVector(IVector<IMatrixCell> ivec){
	Vector<IMatrixCell> remove = new Vector<IMatrixCell>();
	GenericDoubleHashMap<IObject, IObject, IMatrixCell> map = 
	    new GenericDoubleHashMap<IObject, IObject, IMatrixCell>();
	Vector<IMatrixCell> cells = ivec.getUnorderedVector();
	for(int i=0; i<cells.size(); i++){
	    IMatrixCell mc = cells.get(i);
	    IMatrixCell omc = map.get(mc.getColumnIObject(), 
				      mc.getRowIObject());
	    if(omc!=null)
		remove.add(mc);
	    map.put(mc.getRowIObject(), mc.getColumnIObject(), mc);
	}

	for(int i=0; i<remove.size(); i++){
	    IMatrixCell mc = remove.get(i);
	    ivec.remove(mc);
	}
    }


    private static void findUnsymmetricCellsInIVector(IVector<IMatrixCell> ivec){
	Vector<IMatrixCell> remove = new Vector<IMatrixCell>();
	GenericDoubleHashMap<IObject, IObject, IMatrixCell> map = 
	    new GenericDoubleHashMap<IObject, IObject, IMatrixCell>();

	Vector<IMatrixCell> cells = ivec.getUnorderedVector();
	Vector<IMatrixCell> strangeCells = new Vector<IMatrixCell>(cells);

	for(int i=0; i<cells.size(); i++){
	    IMatrixCell mc = cells.get(i);
	    IMatrixCell omc = map.get(mc.getColumnIObject(), 
				      mc.getRowIObject());
	    if(omc!=null){
		//		remove.add(mc);
		strangeCells.remove(mc);
		//		IMatrixCell mc2 = map.get(mc.getRowIObject(), mc.getColumnIObject());
		strangeCells.remove(omc);
	    }
	    map.put(mc.getRowIObject(), mc.getColumnIObject(), mc);
	}

	for(int i=0; i<strangeCells.size(); i++){
	    IMatrixCell mc = strangeCells.get(i);
	    System.out.println(mc.getRowIObject().getString()+", "+
			       mc.getColumnIObject().getString()+": "+
			       mc.getWeight());
	}
	
	System.out.println(strangeCells.size());
    }


    private static void findNumOfIObjectInIMatrixIVector(IVector<IMatrixCell> ivec){
	HashSet<IObject> set = new HashSet<IObject>();
	Vector<IMatrixCell> vec = ivec.getUnorderedVector();
	for(int i=0; i<vec.size(); i++){
	    IMatrixCell mc = vec.get(i);
	    set.add(mc.getRowIObject());
	    set.add(mc.getColumnIObject());
	}

	System.out.println("Number of different IObjects: "+set.size());

    }

}
