package infomat.algorithms.description;

import infomat.vectorspace.*;
import infomat.vectorspace.similarity.*;
import infomat.vectorspace.vector.*;

import mro.util.*;
import mro.util.properties.*;

import java.util.*;


/**
 * Constructs ILabels for IObjectGroups.
 *
 * @version          090115
 * @author           Magnus Rosell
 *
 */
public class CentroidEntropyDescriber extends Describer{

    public CentroidEntropyDescriber(){
	this.properties = getDefaultProperties();
    }

    public CentroidEntropyDescriber(mro.util.properties.Properties properties){
	this.properties = properties;
    }

    public mro.util.properties.Properties getDefaultProperties(){

	mro.util.properties.Properties properties = new mro.util.properties.Properties("Centroid Entropy Describer Properties", CurrentClassGetter.getClassName());
		
	    /*
	try{

	    Property p = new Property("Number of objects in labels", 10, "The number of objects in each label");
	    properties.addProperty(p);

	}catch(PropertyNameConflictException pnce){
	    // Won't happen here
	}
	    */

	return properties;
    }


    public Object getPropertyValue(String name){
	return properties.getPropertyValue(name);
    }

    public void setProperty(String name, Object value) 
	throws PropertyNotFoundException{
	properties.setProperty(name, value);
    }

    public mro.util.properties.Properties getProperties(){
	return properties;
    }

    public void setProperties(mro.util.properties.Properties properties){
	this.properties=properties;
    }



    /*********************************/



    public HashMap<IObjectGroup, IVector<IVectorIndex>> describeGrouping(IObjectGrouping ioging, SparseISimilarity similarity){


	CentroidDescriber cd = new CentroidDescriber();
	HashMap<IObjectGroup, IVector<IVectorIndex>> cdGroupDescriptionMap = 
	    cd.describeGrouping(ioging, similarity);

	HashMap<IObjectGroup, IVector<IVectorIndex>> ret = DescriptionManipulator.multiplyIndexesByEntropy(cdGroupDescriptionMap);

	return ret;

	/*

	HashMap<IObjectGroup, IVector<IVectorIndex>> groupDescriptionMap = 
	    new HashMap<IObjectGroup, IVector<IVectorIndex>>();
	Vector<IObjectGroup> groups = ioging.getGroups();
	for(int g=0; g<groups.size(); g++){
	    IObjectGroup iog = groups.elementAt(g);
	    groupDescriptionMap.put(iog, new IVector<IVectorIndex>());
	}

	Iterator<IVector<IVectorIndex>> it = 
	    cdGroupDescriptionMap.values().iterator();
	while(it.hasNext()){
	    IVector<IVectorIndex> allivec = it.next();
	    Vector<IVectorIndex> vec = allivec.getUnorderedVector();
	    for(int i=0; i<vec.size(); i++){
		IVectorIndex ii = vec.get(i);

		double[] ps = new double[groups.size()];
		double psum =0;
		
		for(int g=0; g<groups.size(); g++){
		    IObjectGroup iog = groups.elementAt(g);
		    IVector<IVectorIndex> ivec = cdGroupDescriptionMap.get(iog);
		    Float f = ivec.getValue(ii);
		    if(f!=null){
			ps[g] = f; 
			psum += f;
		    }
		}
		
		double entropy = 0;
		for(int g = 0; g<ps.length; g++){
		    if(ps[g]!=0){
			ps[g] /= psum;
			entropy += - ps[g] * MoreMath.log(ps[g], 2);
		    }
		}
		
		for(int g=0; g<groups.size(); g++){
		    IObjectGroup iog = groups.elementAt(g);
		    IVector<IVectorIndex> ivec = cdGroupDescriptionMap.get(iog);
		    Float f = ivec.getValue(ii);
		    if(f!=null){
			IVector<IVectorIndex> retVec = 
			    groupDescriptionMap.get(iog);
			retVec.put(ii, (float) (f*entropy));
		    }
		}
	    }
	}

	return groupDescriptionMap;
	*/
    }

    /*********************************/
   
    public String getName(){
	return "Centroid Entropy Describer";
    }



}

