package infomat.algorithms.matrix;

import infomat.vectorspace.*;

/**
 * Matrix Splitter. Not redy. Not used.
 *      
 * @version          080304
 * @author           Magnus Rosell
 */
public class IMatrixSplitter{

    public IMatrix[] splitAccordingToGrouping(IMatrix matrix, IObjectGrouping ioging){
	IMatrix[] matrixes = new IMatrix[ioging.numberOfIObjectGroups()];

	boolean rowGrouping = matrix.rowObject(ioging);

	Vector<IObjectGroup> groups = ioging.getGroups();
	for(int i=0; i<groups.size(); i++){
	    IObjectGroup group = groups.elementAt(i);
	    IObjectGroup correspondingGroup = 
		matrix.constructCorrespondingGroup(group);
	    
	    IMatrix m = null;
	    if(rowGrouping)
		m  = matrix.subMatrix(group, correspondingGroup);
	    else
		m  = matrix.subMatrix(correspondingGroup, group);
		
	    matrixes[i] = m;
	}
	return matrixes;
    }


    public IMatrix[][] splitAccordingToTwoGroupingsAlongDifferentDimensions(IMatrix matrix, IObjectGrouping ioging1, IObjectGrouping ioging2){

	IMatrix[][] matrixes = 
	    new IMatrix[ioging1.numberOfIObjectGroups()][ioging2.numberOfIObjectGroups()];

	boolean rowGrouping = matrix.rowObject(ioging1);

	Vector<IObjectGroup> groups1 = ioging2.getGroups();
	Vector<IObjectGroup> groups2 = ioging2.getGroups();

	for(int i=0; i<groups1.size(); i++){
	    IObjectGroup group1 = groups1.elementAt(i);

	    for(int j=0; j<groups2.size(); j++){
		IObjectGroup group2 = groups2.elementAt(j);
	    
		IMatrix m = null;
		if(rowGrouping)
		    m  = matrix.subMatrix(group1, group2);
		else
		    m  = matrix.subMatrix(group2, group1);
		
		matrixes[i][j] = m;
	    }
	}
	return matrixes;
    }




}
