package infomat.bridges.jsdm;

import infomat.vectorspace.*;

import mro.util.*;
import mro.util.properties.*;

import moj.ri.*;


import java.io.*;
import java.util.*; 
import java.util.zip.*;

import org.xml.sax.Attributes;
import org.xml.sax.InputSource;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.XMLReaderFactory;

/**
 * 
 * @version          081014
 * @author           Magnus Rosell
 */
public class RICompositionalRepresentation{
    
    
    private HashMap<IObject, float[]> ioReprMap;


    public RICompositionalRepresentation(IMatrix matrix, boolean row, JSDMWrapper jsdmWrapper){
	ioReprMap = new HashMap<IObject, float[]>();
	
	Vector<IObject> iovec = matrix.getColumnIObjectSet().getOrdered();
	if(row)
	    iovec = matrix.getRowIObjectSet().getOrdered();
	for(int i=0; i<iovec.size(); i++){
	    IObject io = iovec.get(i);
	    
	    Vector cells = matrix.getCellsWith(io);

	    IMatrixCell mc = (IMatrixCell) cells.get(0);
	    IObject otherIO = mc.getOtherIObject(io);
	    float[] otherIORI = jsdmWrapper.getWrappedRepresentation(otherIO);
	    
	    float[] ioRI = new float[otherIORI.length];

	    for(int j=0; j<cells.size(); j++){
		mc = (IMatrixCell) cells.get(j);
		otherIO = mc.getOtherIObject(io);
		//		System.out.println("otherIO: "+otherIO.getString());
		float localWeight = mc.getLocalWeight();
		otherIORI = jsdmWrapper.getWrappedRepresentation(otherIO);

		


		//		printArray(otherIORI);

		//		if(otherIORI!=null && otherIORI.length>0)

		if(otherIORI==null){
		    System.out.println(otherIO.getString()+" : null");

		}else if(otherIORI.length<ioRI.length){
		    System.out.println(otherIO.getString()+" : "+otherIORI.length);
		}else
		    add(ioRI, otherIORI, localWeight);

	    }
	    normalize(ioRI);
	    ioReprMap.put(io, ioRI);

	}

    }

    private void printArray(float[] array){
	for(int i=0; i<array.length; i++){
	    System.out.print(array[i]+", ");
	}
	System.out.println();
    }

    private void add(float[] cumulator, float[] addition, float weight){
	for(int i=0; i<cumulator.length; i++){
	    cumulator[i] += weight * addition[i];
	}
    }

    private void normalize(float[] repr){
	//	Iterator<float[]> it = ioReprMap.values().iterator();
	double sum = 0.0;
	for(int i=0; i<repr.length; i++)
	    sum += Math.pow(repr[i], 2);
	for(int i=0; i<repr.length; i++)
	    repr[i] = (float) Math.sqrt(Math.pow(repr[i],2)/sum);
    }


    public float[] getRepresentation(IObject io){
	return ioReprMap.get(io);
    }




}
