package infomat.view;

import infomat.vectorspace.IObjectGrouping;
import infomat.view.grouping.settings.GroupingColoring;
import infomat.view.grouping.settings.GroupingSettings;
import infomat.view.grouping.settings.GroupingSettingsManager;
import infomat.view.menu.ToolbarView;
import infomat.view.picture.*;

import java.util.*;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

public class InfomatOverview extends JFrame 
    implements ComponentListener{ //, Observer{

    private Container container;
    private SparsePicture sparsePicture = null;
    private boolean visible = false;
	
    private InfomatModel model;
    private InfomatView view;
    private ToolbarView toolbarView;
	
    private int WIDTH;
    private int HEIGHT;
    private int oldWIDTH;
    private int oldHEIGHT;

    //private float oldOpacity;

    private boolean forceChange=false;
    private boolean opacityChanged=false;

    private JPanel thePanel;
	
    public static final Color ZOOMRECT_COLOR=Color.BLACK; //RED;
    public static final Dimension OVERVIEW_PREFERRED_SIZE = 
	new Dimension(250,250);
	

    public InfomatOverview(String title, InfomatModel model, 
			   InfomatView view, ToolbarView toolbarView) {
	super(title);
	this.model = model;
	this.view = view;
	this.toolbarView=toolbarView;
	
	setPreferredSize(OVERVIEW_PREFERRED_SIZE);
	setSize(OVERVIEW_PREFERRED_SIZE);
	container = getContentPane();
	thePanel = new JPanel();
	thePanel.setPreferredSize(OVERVIEW_PREFERRED_SIZE);
	container.add(thePanel);
	//setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		
	GridLayout layout = new GridLayout(1,1);
	setLayout(layout);
	layout = new GridLayout(1,1);
	thePanel.setLayout(layout);

		
	pack();
		
	/*
	  sparsePicture = new SparsePicture(new Dimension(700,70));
	  add(sparsePicture);
	  setVisible(true);
	*/


	//model.addObserver(this);
	WIDTH = HEIGHT = 0;
	//	pixels = null;
	addComponentListener(this);
	//addWindowListener(this);
		
		
		
    }

    public void setVisible(boolean visible){
	super.setVisible(visible);
	this.visible=visible;
    }

    public boolean getVisible(){
	return visible;
    }

    /*
      public void paintComponent(Graphics g) {
      super.paintComponent(g);
      System.out.println("-------------------------------------");
      System.out.println("paintComponent - InfomatViewRectangle");

      }
    */

    /** Called by the Observer */
    /*
      public void update(Observable o, Object arg) {
      System.out.println("Overview - update");
      if (HEIGHT == 0 || WIDTH == 0 || !model.hasIMatrix()){
      sparsePicture=null;
      }else if (sparsePicture == null){
      changePartPictures();
      }else if (sparsePicture != null){
      if(parametersChanged()){ // || model.inquireFundamentalChanges()){
      changePartPictures();
      }
      else{
      if(opacityChanged){
      sparsePicture.makeImage();
      opacityChanged=false;
      }
      }

      }

      thePanel.revalidate();
      repaint();
      //revalidate();
      }
    */
	
    protected void changePartPictures(){
	if(getVisible()){
	    System.out.println("Overview - changePartPictures");

	    if(model==null){// || model.getIMatrix()==null){
		removeAll();
		return; 
	    }
			
	    Dimension d = model.getGUIIMatrix().getCurrentSize();
			
	    int rowFrom = 0;
	    int rowTo = d.height;
	    int colFrom = 0;
	    int colTo = d.width;
	
	    sparsePicture = 
		SparsePictureConstructor.zoom(view, model.getGUIIMatrix(), 
					      thePanel.getSize(), 
					      colFrom, colTo, rowFrom, rowTo);

	    if(sparsePicture==null){
		thePanel.removeAll();
	    }else{


		sparsePicture.setView(view);
		//sparsePicture.adjustOpacity(1 - view.getMinOpacity(), view.getMaxOpacity());
			
		// Opacity
		IObjectGrouping rowGrouping = model.getGUIIMatrix().getCurrentRowGrouping();
		GroupingSettings gs = view.getRowGroupingManager().getSettingsForGrouping(rowGrouping);		
		sparsePicture.adjustOpacity(gs.getMinOpacity(), gs.getMaxOpacity());
	
		// Column Color Opacity
		boolean row = false;
		GroupingSettingsManager gm = view.getGroupingManager(row);
		GroupingColoring colColoring = gm.getCurrentColoring();
		if(colColoring!=null){
		    IObjectGrouping colGrouping = colColoring.getIObjectGrouping();
		    gs = gm.getSettingsForGrouping(colGrouping);		
		    sparsePicture.adjustColumnColorOpacity(gs.getMinOpacity(), gs.getMaxOpacity());
		}
			
			
		//	sparsePicture.adjustColor(view.getMinColorComponentValue());
	
		boolean overviewPicture = true;
		sparsePicture.setOverviewPicture(overviewPicture);
	
		sparsePicture.makeImage();
	
		thePanel.removeAll();
		thePanel.add(sparsePicture);
		//sparsePicture.setSize(getSize());
		//container.revalidate();
		thePanel.revalidate();

	    }
	}
    }


    public void forceChange(){
	forceChange=true;
    }

    public void setOpacityChanged(){
	opacityChanged=true;
    }
	
    protected SparsePicture getSparsePicture(){
	return sparsePicture;
    }
	
    protected void makeImage(){
	sparsePicture.makeImage();
	thePanel.revalidate();
	repaint();
    }
	
    private boolean parametersChanged(){
	boolean ret=false;
	if(WIDTH!=oldWIDTH) ret=true;
	if(HEIGHT!=oldHEIGHT) ret=true;
	//if(view.getMinOpacity() != oldOpacity) ret = true;

	oldWIDTH=WIDTH;
	oldHEIGHT=HEIGHT;
	//oldOpacity = view.getMinOpacity();

	if(forceChange){
	    ret = forceChange;
	    forceChange=false;
	}

	return ret;
    }

    public void componentHidden(ComponentEvent e) {
    }

    public void componentMoved(ComponentEvent e) {
    }

    public void componentResized(ComponentEvent e) {
	Component c = e.getComponent();
	System.out.println("componentResized event from "
			   + c.getClass().getName() + "; new size: " + c.getSize().width
			   + ", " + c.getSize().height);
	WIDTH = c.getSize().width;
	HEIGHT = c.getSize().height;
	//update(null, null);
	if(parametersChanged() && model.getIMatrix()!=null)
	    changePartPictures();
    }

    public void componentShown(ComponentEvent e) {
    }
	
	
    /*	
      public void windowActivated(WindowEvent e){
      //Invoked when the Window is set to be the active Window.
      }
      public void windowClosed(WindowEvent e){
      //Invoked when a window has been closed as the result of calling dispose on the window.
      toolbarView.pressOverview();
      System.out.println("Stnger overview");
      }
      public void windowClosing(WindowEvent e){
      //Invoked when the user attempts to close the window from the window's system menu.
      }
      public void windowDeactivated(WindowEvent e){
      //Invoked when a Window is no longer the active Window.
      }
      public void windowDeiconified(WindowEvent e){
      //Invoked when a window is changed from a minimized to a normal state.
      }
      public void windowIconified(WindowEvent e){
      //Invoked when a window is changed from a normal to a minimized state.
      }
      public void windowOpened(WindowEvent e){
      //Invoked the first time a window is made visible.
      }
	
    */

}
