package infomat.view;

import java.awt.*;
import javax.swing.*;

/**
 * Starts everything.
 */
public class MainWindow {

    private JFrame frame;

    private infomat.view.menu.Menu menu;

    private SessionPanel mySessionPanel;

    private InfomatModel infomatModel;



    /**
     * Run!
     */
    public void run() {
	frame = new JFrame("Infomat");
	Container container = frame.getContentPane();

	infomatModel = new InfomatModel(this);
	mySessionPanel = new SessionPanel(infomatModel);
	mySessionPanel.setLayout(new BoxLayout(mySessionPanel, BoxLayout.Y_AXIS));

	menu = new 
	    infomat.view.menu.Menu(this, infomatModel, 
				   mySessionPanel.getToolbarController(), 
				   mySessionPanel.getInfomatView());
	container.add(mySessionPanel);


	frame.setJMenuBar(menu);
	frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	frame.pack();
	frame.setVisible(true);
    }






    /** Get the sessionFrame that is in MainWindow */
    public JFrame getMainFrame() {
	return frame;
    }

    /** Get the frame that is in the MainWindows frame */
    public SessionPanel getSessionPanel() {
	return mySessionPanel;
    }

    /**
     * Start Infomat Interface!
     * 
     * @param args
     *            ignored
     */
    public static void main(String args[]) {
	new MainWindow().run();
    }
}
