package infomat.view.grouping.settings;

import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import java.awt.*;

import infomat.view.*;
import infomat.view.picture.*;

public class OpacityPanel extends JPanel implements ChangeListener{

	private InfomatModel model;
	private InfomatView view;
	private GroupingSettings groupingSettings;
	private OpacitySlider minSlider;
	private OpacitySlider maxSlider;
	
	public OpacityPanel(InfomatModel model, InfomatView view, 
			GroupingSettings groupingSettings, Dimension d){
		this.model=model;
		this.view=view;
		this.groupingSettings=groupingSettings;
		
		Label l = new Label("Opacity"); 
		add(l);
		
		boolean max=false;
		int value = Math.round(OpacitySlider.OPACITY_MAX * 
								groupingSettings.getMinOpacity());
		minSlider = new OpacitySlider(max, value, this);
		max=true;
		value = Math.round(OpacitySlider.OPACITY_MAX * 
							groupingSettings.getMaxOpacity());
		maxSlider = new OpacitySlider(max, value, this);
		
		add(minSlider);
		add(maxSlider);
		
		/*
		Dimension d = getPreferredSize();
		int height = (int) l.getPreferredSize().getHeight();
		d = new Dimension(3*height, (int)d.getWidth());
		*/
		
		//Dimension d = new Dimension(50, 100); //new Dimension(l.getPreferredSize());
		setPreferredSize(d);
		setMaximumSize(d);
		setMinimumSize(d);
		
		
	}
	
	
    public void stateChanged(ChangeEvent e) {
    	JSlider source = (JSlider) e.getSource();
    	if (!source.getValueIsAdjusting()) {
    	    System.out.println("OpacitySlider value changed: "
    			       + source.getValue());
    	    if(source == minSlider.getSlider()){
    	    	groupingSettings.setMinOpacity(source.getValue()/(float)OpacitySlider.OPACITY_MAX);
    	    	/*
    	    	if(groupingSettings.opacityChanged()){
    	    		groupingSettings.setOpacity();
    	    		SparsePicture sparsePicture = view.getSparsePicture();
    	    		sparsePicture.adjustOpacity(groupingSettings.getMinOpacity(), groupingSettings.getMaxOpacity());
        	    	model.update();
    	    	}
    	    	*/
    	    	model.update();
    	    }else if(source == maxSlider.getSlider()){
    	    	groupingSettings.setMaxOpacity(source.getValue()/(float)OpacitySlider.OPACITY_MAX);
    	    	/*
    	    	if(groupingSettings.opacityChanged()){
    	    		groupingSettings.setOpacity();
    	    		SparsePicture sparsePicture = view.getSparsePicture();
    	    		sparsePicture.adjustOpacity(groupingSettings.getMinOpacity(), groupingSettings.getMaxOpacity());
        	    	model.update();
    	    	}
    	    	*/
    	    	model.update();
    	    }
    	    
    	    
    	}
    }

	
}
