package infomat.view.selector;

import infomat.algorithms.grouping.*;
import infomat.io.*;
import infomat.vectorspace.*;
import infomat.vectorspace.similarity.*;
import infomat.view.*;
import infomat.view.picture.*;
import infomat.view.util.*;
import infomat.view.grouping.settings.*;
import mro.util.properties.*;
import mro.util.properties.Properties;
import mro.util.properties.dialog.*;

import java.awt.*;
import java.awt.Dialog.*;//ModalityType;
import java.awt.event.*;
import javax.swing.border.*;
import java.util.*;
import java.io.*;

import javax.swing.*;


	
/**
 *
 * @version          090316
 * @author           Magnus Rosell
 */
public class SelectorFrame extends JFrame
    implements Observer{

    public static Dimension SELECTORFRAME_PREFERRED_SIZE = 
	new Dimension(700, 600);

    private InfomatModel model;
    private InfomatView view;

    private JPanel mainPanel;
    private boolean visible=true;

    private SimpleSelectionPanel rowAndColPanel;
    private SimpleSelectionPanel rowPanel;
    private SimpleSelectionPanel colPanel;


    public SelectorFrame(InfomatModel model, InfomatView view){
	super("Selector");
	this.model=model;
	this.view = view;

	model.addObserver(this);

	setVisible(visible);
	setPreferredSize(SELECTORFRAME_PREFERRED_SIZE);

	Container container = getContentPane();
	mainPanel = new JPanel();
	container.add(mainPanel);

	//	rowAndColPanel = new SimpleSelectionPanel("Rows and Columns:");
	rowPanel = new SimpleSelectionPanel("Rows:");
	colPanel = new SimpleSelectionPanel("Columns:");

	mainPanel.setLayout(new BoxLayout(mainPanel, BoxLayout.Y_AXIS));

	putAll();
	pack();
    }


    public void putAll(){
	mainPanel.removeAll();
	
	


	//	mainPanel.add(rowAndColPanel);
	mainPanel.add(rowPanel);
	mainPanel.add(colPanel);
	mainPanel.revalidate();
	repaint();
    }


    public void invert(){
	//	similarityManager.invert();
	putAll();
    }

  
    /** Called by the Observable */
    public void update(Observable o, Object arg) {
	//	rowSimPanel.putAll();
	//	colSimPanel.putAll();
    }


    public void paint(Graphics g){
	super.paint(g);
    }

    public void toggleVisible(){
	visible=!visible;
	super.setVisible(visible);
    }


    public IObjectGroup getSelectedRowGroup(){
	if(rowPanel.isSelected()){

	    GUIIMatrix guiMatrix = model.getGUIIMatrix();

	    if(rowPanel.all()){
		return guiMatrix.getIMatrix().getRowIObjectSet();
	    }else if(rowPanel.overview()){
		return guiMatrix.getCurrentRowGrouping();
	    }else if(rowPanel.mainview()){
		IObjectGroup group = guiMatrix.getCurrentRowGrouping();
		SparsePicture sp = view.getSparsePicture();
		return group.subGroup(sp.getRowFrom(), sp.getRowTo()-1);
	    }
	}

	// tmp
	GUIIMatrix guiMatrix = model.getGUIIMatrix();
	return guiMatrix.getIMatrix().getRowIObjectSet();
    }


    public IObjectGroup getSelectedColumnGroup(){
	if(colPanel.isSelected()){

	    GUIIMatrix guiMatrix = model.getGUIIMatrix();

	    if(colPanel.all()){
		return guiMatrix.getIMatrix().getColumnIObjectSet();
	    }else if(colPanel.overview()){
		return guiMatrix.getCurrentColumnGrouping();
	    }else if(colPanel.mainview()){
		IObjectGroup group = guiMatrix.getCurrentColumnGrouping();
		SparsePicture sp = view.getSparsePicture();
		return group.subGroup(sp.getColFrom(), sp.getColTo()-1);
	    }
	}

	// tmp
	GUIIMatrix guiMatrix = model.getGUIIMatrix();
	return guiMatrix.getIMatrix().getColumnIObjectSet();
    }



 
}

