package mro.util;

import java.util.*; 

/**
 * For convenient trace printing. 
 * Has both class and object methods... 
 * @version          070509
 * @author           Magnus Rosell
 */
public class TracePrinter{

	
	/****************************************/
	private boolean traceOn=false;
	
	public TracePrinter(boolean traceOn){
		this.traceOn=traceOn;
	}
	
	public void print(Object o){
		if(traceOn)
			System.out.print(o);
	}
	
	public void println(Object o){
		if(traceOn)
			System.out.println(o);
	}
	
	public void println(){
		if(traceOn)
			System.out.println();
	}
	/****************************************/
	private static boolean traceOnStatic=false;
	
	public static void staticPrint(Object o){
		if(traceOnStatic)
			System.out.print(o);
	}
	
	public static void staticPrintln(Object o){
		if(traceOnStatic)
			System.out.println(o);
	}
	
	public static void staticPrintln(){
		if(traceOnStatic)
			System.out.println();
	}
	/****************************************/
	
	
}
