#include <math.h>

// -------------------------------------------------------------------
// References to Fortran functions
// -------------------------------------------------------------------

// Mangle names for Fortran
#define dsaupd dsaupd_
#define dseupd dseupd_
#define dnaupd dnaupd_
#define dneupd dneupd_
		
// Eigensystem decomposition - real-valued symmetric matrices
extern "C" void dsaupd(int *ido, char *bmat, int *n, char *which,
		int *nev, double *tol, double *resid, int *ncv,
		double *v, int *ldv, int *iparam, int *ipntr,
		double *workd, double *workl, int *lworkl,
		int *info);

// Extract eigenvalues and eigenvectors - real-valued symmetric matrices
extern "C" void dseupd(int *rvec, char *All, int *select, double *d,
		double *v, int *ldv, double *sigma,
		char *bmat, int *n, char *which, int *nev,
		double *tol, double *resid, int *ncv, double *v2,
		int *ldv2, int *iparam, int *ipntr, double *workd,
		double *workl, int *lworkl, int *ierr);
		
// Eigensystem decomposition - real-valued non-symmetric matrices
extern "C" void dnaupd(int *ido, char *bmat, int *n, char *which,
		int *nev, double *tol, double *resid, int *ncv,
		double *v, int *ldv, int *iparam, int *ipntr,
		double *workd, double *workl, int *lworkl,
		int *info);

// Extract eigenvalues and eigenvectors - real-valued non-symmetric matrices
extern "C" void dneupd(int *rvec, char *howmny, int *select,
		double *dr, double *di, double *Z,
		int *ldz, double *sigmar,
		double *sigmai, double *workev,
		char *bmat, int *n, char *which,
		int *nev, double *tol, double *resid,
		int *ncv, double *V, int *ldv,
		int *iparam, int *ipntr,
		double *workd, double *workl,
		int *lworkl, int *info);

